<!--检测项目编辑列表（添加、导入检测项目）-->
<template>
  <div>
    <Modal
      v-model="showModal"
      :mask-closable="false"
      :width="690"
      @on-cancel="_cancel"
      title="检测项目管理"
    >
      <Row>
        <!-- 表格 -->
        <Col span="24">
          <PTVXETable ref="pageTable" :loading="true"
                      :get-page="itemList" :icon-msg="iconMsg" @on-result-change="_tableResultChange" hide-page="true" select-data>
            <vxe-table-column
              v-for="item in pageColumns"
              :key="item.key"
              :field="item.key"
              :title="item.title"
              :min-width="item.width?item.width:200"
              :fixed="item.fixed?item.fixed:undefined" sortable>
            <template slot-scope="scope">
              <span v-if="item.key==='judged'">
                {{ scope.row[item.key]===1?'是':'否' }}
              </span>
              <div v-else-if="item.key==='compareSymbol'" @click.stop="_handleRow(scope)">
                <el-input
                  v-model="scope.row.compareSymbol"
                  placeholder="请输入比较符"
                />
              </div>
              <div v-else-if="item.key==='limitValue'" @click.stop="_handleRow(scope)">
                <el-input
                  v-model="scope.row.limitValue"
                  placeholder="请输入限值"
                />
              </div>
              <div v-else-if="item.key==='unit'" @click.stop="_handleRow(scope)">
                <el-input
                  v-model="scope.row.unit"
                  placeholder="请输入单位"
                />
              </div>
              <div v-else-if="item.key==='code'" @click.stop="_handleRow(scope)">
                <el-input
                  v-model="scope.row.code"
                  style="width: 130px;"
                  blur
                  placeholder="请选择检测依据"
                />
                <i @click.stop="_selectjudgeBasis(scope.$index)" style="cursor: pointer;font-size: 14px;" class="icons iconfont pt-search icon-search"></i>
              </div>
              <span v-else>
                {{ scope.row[item.key] }}
              </span>
            </template>
            </vxe-table-column>
          </PTVXETable>
        </Col>
      </Row>
      <div slot="footer">
        <modal-footer ref="footerModal" :footer="footerList" @on-result-change="_footerResult" />
      </div>
    </Modal>
  </div>
</template>
<script>
import { soilAptitude } from '../../../api'

export default {
  components: {},
  data() {
    return {
      formObj: {
        catalogueId: '',
        name: '',
        code: '',
        standardCode: '',
        standardName: ''
      },
      showModal: false,
      searchOpen: false,
      btn: [],
      index: '',
      iconMsg: [
        {
          type: 'md-trash',
          id: '',
          name: '删除'
        }
      ],
      footerList: [
        { id: '', name: '取消', type: '' },
        { id: '', name: '保存', type: 'primary' }
      ],
      pageColumns: [
        { title: '试验名称', key: 'name', width: 140 },
        { title: '大类', key: 'mainType', width: 140 },
        { title: '小类', key: 'smallType', width: 140 },
        { title: '方法', key: 'testMethod', width: 180 }
      ],
      catalogueId: '',
      itemList: {
        records: []
      },
      selectData: [],
      originalList: []
    }
  },
  methods: {
    _open(itemList) {
      this.itemList.records = []
      this.formObj = this.$resetFields(this.formObj)
      this.showModal = true
      this.itemList.records = itemList
      this.$refs.pageTable._hideLoading()
      this.$refs.pageTable._clearSelection()
      // if (catalogueId) {
      //   this._page()
      // }
    },
    _handleRow(scope) {
      console.log(scope)
    },
    _selectjudgeBasis(index) {
      console.log(index)
      this.index = index
      this.$refs.EditModal._open()
    },
    _formSearch() {
      console.log(this.formObj.name)
      const searchItem = []
      for (let i = 0; i < this.itemList.records.length; i++) {
        if (this.itemList.records[i].name === this.formObj.name) {
          console.log(this.itemList.records[i])
          searchItem.push(this.itemList.records[i])
        }
      }
      this.itemList.records = searchItem
    },
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '保存':
          this._ok()
          break
      }
    },
    _page: async function() {
      // this.$refs.pageTable._page('search-form-package', 'FoodJudgeBasis/page')
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await soilAptitude.page(this.$serializeForm(this.formObj))
      if (result) {
        console.log(result)
        this.getPage = result
        this.$refs.pageTable._hideLoading()
      }
    },
    _btnClick(msg) {
      switch (msg) {
        case '导入检测项目':
          this.$refs.relItemModal._open(this.catalogueId)
          break
      }
    },
    // 操作列操作
    _iconClick(res, data) {
      switch (res) {
        case '删除':
          this.itemList.records.splice(data.index, 1)
          break
      }
    },
    // 删除
    _deleteById(id) {
      this.$Modal.confirm({
        title: '提示',
        content: '确定删除该数据？',
        onOk: () => {
          this._deleteOk(id)
        }
      })
    },
    _deleteOk(id) {
      // const result = await drugCatalogueItem.deleteById(id)
      this.itemList.splice(id, 1)
      this.getPage.records = this.itemList
      this.$Message.success('已删除')
    },
    // table结果  返回整行
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'selectData':
          this.selectData = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
      }
    },
    _ok() {
      const data = this.itemList.records
      this._saveCatalogueItem(data)
    },
    _saveCatalogueItem(data) {
      this.showModal = false
      this.$emit('on-result-change', data)
      this._hideLoading()
    },
    _cancel() {
      const data = this.itemList.records
      this._saveCatalogueItem(data)
      this.selectData = []
      this.showModal = false
    },
    _visibleChange() {
      const data = this.itemList.records
      this._saveCatalogueItem(data)
      this.selectData = []
      this.showModal = false
    },
    _hideLoading() {
      this.$refs.footerModal._hideLoading()
    }
  }
}
</script>
